diff --git a/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java b/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java
index 85ef4fa0fe93f078ec84c9073a31900ad8c1d27a..7b0813d715fa97c7db69f1e020a189c7d05ed6a3 100644
--- a/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java
+++ b/base/common/src/com/netscape/cms/servlet/profile/ProfileSubmitServlet.java
@@ -17,58 +17,38 @@
 // --- END COPYRIGHT BLOCK ---
 package com.netscape.cms.servlet.profile;
 
-import java.math.BigInteger;
-import java.security.cert.CertificateEncodingException;
-import java.security.cert.X509Certificate;
-import java.util.Date;
 import java.util.Enumeration;
+import java.util.HashMap;
 import java.util.Locale;
-import java.util.StringTokenizer;
 
 import javax.servlet.ServletConfig;
 import javax.servlet.ServletException;
 import javax.servlet.http.HttpServletRequest;
 import javax.servlet.http.HttpServletResponse;
 
-import netscape.security.x509.BasicConstraintsExtension;
 import netscape.security.x509.X509CertImpl;
 import netscape.security.x509.X509CertInfo;
 
 import org.w3c.dom.Node;
 
 import com.netscape.certsrv.apps.CMS;
-import com.netscape.certsrv.authentication.IAuthToken;
-import com.netscape.certsrv.authority.IAuthority;
+import com.netscape.certsrv.authentication.EAuthException;
+import com.netscape.certsrv.authorization.EAuthzException;
+import com.netscape.certsrv.base.BadRequestDataException;
 import com.netscape.certsrv.base.EBaseException;
-import com.netscape.certsrv.base.MetaInfo;
-import com.netscape.certsrv.base.SessionContext;
-import com.netscape.certsrv.ca.ICertificateAuthority;
-import com.netscape.certsrv.dbs.certdb.ICertRecord;
-import com.netscape.certsrv.dbs.certdb.ICertificateRepository;
-import com.netscape.certsrv.logging.ILogger;
-import com.netscape.certsrv.profile.EDeferException;
 import com.netscape.certsrv.profile.EProfileException;
-import com.netscape.certsrv.profile.ERejectException;
 import com.netscape.certsrv.profile.IEnrollProfile;
 import com.netscape.certsrv.profile.IProfile;
-import com.netscape.certsrv.profile.IProfileAuthenticator;
-import com.netscape.certsrv.profile.IProfileContext;
-import com.netscape.certsrv.profile.IProfileInput;
 import com.netscape.certsrv.profile.IProfileOutput;
-import com.netscape.certsrv.profile.IProfileSubsystem;
 import com.netscape.certsrv.property.IDescriptor;
-import com.netscape.certsrv.request.INotify;
 import com.netscape.certsrv.request.IRequest;
-import com.netscape.certsrv.request.IRequestQueue;
-import com.netscape.certsrv.request.RequestId;
-import com.netscape.certsrv.request.RequestStatus;
 import com.netscape.certsrv.template.ArgList;
 import com.netscape.certsrv.template.ArgSet;
-import com.netscape.certsrv.util.IStatsSubsystem;
-import com.netscape.cms.servlet.common.AuthCredentials;
+import com.netscape.cms.servlet.cert.EnrollmentProcessor;
+import com.netscape.cms.servlet.cert.RenewalProcessor;
 import com.netscape.cms.servlet.common.CMSRequest;
+import com.netscape.cms.servlet.processors.Processor;
 import com.netscape.cmsutil.util.Cert;
-import com.netscape.cmsutil.util.Utils;
 import com.netscape.cmsutil.xml.XMLObject;
 
 /**
@@ -83,31 +63,9 @@ public class ProfileSubmitServlet extends ProfileServlet {
      *
      */
     private static final long serialVersionUID = 7557922703180866442L;
-    private static final String ARG_AUTH_TOKEN = "auth_token";
-    private static final String ARG_REQUEST_OWNER = "requestOwner";
-    private static final String PROP_PROFILE_ID = "profileId";
-    private static final String PROP_AUTHORITY_ID = "authorityId";
     private final static String SUCCESS = "0";
     private final static String FAILED = "1";
 
-    private String mProfileId = null;
-    private String mProfileSubId = null;
-    private String mAuthorityId = null;
-
-    private final static String[] SIGNED_AUDIT_AUTOMATED_REJECTION_REASON = new String[] {
-
-    /* 0 */"automated profile cert request rejection:  "
-            + "indeterminate reason for inability to process "
-            + "cert request due to an EBaseException"
-        };
-    private final static String LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED =
-            "LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED_5";
-
-    private final static String LOGGING_SIGNED_AUDIT_AUTH_FAIL =
-            "LOGGING_SIGNED_AUDIT_AUTH_FAIL_4";
-    private final static String LOGGING_SIGNED_AUDIT_AUTH_SUCCESS =
-            "LOGGING_SIGNED_AUDIT_AUTH_SUCCESS_3";
-
     public ProfileSubmitServlet() {
     }
 
@@ -123,273 +81,122 @@ public class ProfileSubmitServlet extends ProfileServlet {
      */
     public void init(ServletConfig sc) throws ServletException {
         super.init(sc);
-        mAuthorityId = sc.getInitParameter(PROP_AUTHORITY_ID);
-        mProfileId = sc.getInitParameter(PROP_PROFILE_ID);
     }
 
-    private void setInputsIntoContext(HttpServletRequest request, IProfile profile, IProfileContext ctx) {
-        // passing inputs into context
-        Enumeration<String> inputIds = profile.getProfileInputIds();
-
-        if (inputIds != null) {
-            while (inputIds.hasMoreElements()) {
-                String inputId = inputIds.nextElement();
-                IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration<String> inputNames = profileInput.getValueNames();
-
-                while (inputNames.hasMoreElements()) {
-                    String inputName = inputNames.nextElement();
-                    if (request.getParameter(inputName) != null) {
-                        // all subject name parameters start with sn_, no other input parameters do
-                        if (inputName.matches("^sn_.*")) {
-                            ctx.set(inputName, escapeValueRfc1779(request.getParameter(inputName), false).toString());
-                        } else {
-                            ctx.set(inputName, request.getParameter(inputName));
-                        }
-                    }
-                }
-            }
-        }
-
-    }
-
-    /*
-     * fill input info from "request" to context.
-     * This is expected to be used by renewal where the request
-     * is retrieved from request record
+    /**
+     * Process the HTTP request
+     * <P>
+     *
+     * (Certificate Request Processed - either an automated "EE" profile based cert acceptance, or an automated "EE"
+     * profile based cert rejection)
+     * <P>
+     *
+     * <ul>
+     * <li>http.param profileId ID of profile to use to process request
+     * <li>signed.audit LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED used when a certificate request has just been
+     * through the approval process
+     * </ul>
+     *
+     * @param cmsReq the object holding the request and response information
+     * @exception EBaseException an error has occurred
      */
-    private void setInputsIntoContext(IRequest request, IProfile profile, IProfileContext ctx, Locale locale) {
-        // passing inputs into context
-        Enumeration<String> inputIds = profile.getProfileInputIds();
-
-        if (inputIds != null) {
-            while (inputIds.hasMoreElements()) {
-                String inputId = inputIds.nextElement();
-                IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration<String> inputNames = profileInput.getValueNames();
-
-                while (inputNames.hasMoreElements()) {
-                    String inputName = inputNames.nextElement();
-                    String inputValue = "";
-                    CMS.debug("ProfileSubmitServlet: setInputsIntoContext() getting input name= " + inputName);
-                    try {
-                        inputValue = profileInput.getValue(inputName, locale, request);
-                    } catch (Exception e) {
-                        CMS.debug("ProfileSubmitServlet: setInputsIntoContext() getvalue() failed: " + e.toString());
-                    }
-
-                    if (inputValue != null) {
-                        CMS.debug("ProfileSubmitServlet: setInputsIntoContext() setting value in ctx:" + inputValue);
-                        ctx.set(inputName, inputValue);
-                    } else {
-                        CMS.debug("ProfileSubmitServlet: setInputsIntoContext() value null");
-                    }
-                }
-            }
-        }
 
-    }
+    public void process(CMSRequest cmsReq) throws EBaseException {
+        HttpServletRequest request = cmsReq.getHttpReq();
+        HttpServletResponse response = cmsReq.getHttpResp();
+        boolean xmlOutput = getXMLOutput(request);
 
-    private void setCredentialsIntoContext(HttpServletRequest request, IProfileAuthenticator authenticator,
-            IProfileContext ctx) {
-        Enumeration<String> authIds = authenticator.getValueNames();
+        Locale locale = getLocale(request);
 
-        if (authIds != null) {
-            CMS.debug("ProfileSubmitServlet:setCredentialsIntoContext() authNames not null");
-            while (authIds.hasMoreElements()) {
-                String authName = authIds.nextElement();
+        HashMap<String, Object> results = null;
+        String renewal = request.getParameter("renewal");
 
-                CMS.debug("ProfileSubmitServlet:setCredentialsIntoContext() authName:" +
-                        authName);
-                if (request.getParameter(authName) != null) {
-                    CMS.debug("ProfileSubmitServlet:setCredentialsIntoContext() authName found in request");
-                    ctx.set(authName, request.getParameter(authName));
-                } else {
-                    CMS.debug("ProfileSubmitServlet:setCredentialsIntoContext() authName not found in request");
-                }
-            }
-        } else {
-            CMS.debug("ProfileSubmitServlet:setCredentialsIntoContext() authIds` null");
-        }
-    }
-
-    String getUidFromDN(String userdn) {
-        StringTokenizer st = new StringTokenizer(userdn, ",");
-        while (st.hasMoreTokens()) {
-            String t = st.nextToken();
-            int i = t.indexOf("=");
-
-            if (i == -1) {
-                continue;
-            }
-            String n = t.substring(0, i);
-            if (n.equalsIgnoreCase("uid")) {
-                String v = t.substring(i + 1);
-                CMS.debug("ProfileSubmitServlet:: getUidFromDN(): uid found:" + v);
-                return v;
+        try {
+            if ((renewal != null) && (renewal.equalsIgnoreCase("true"))) {
+                CMS.debug("ProfileSubmitServlet: isRenewal true");
+                RenewalProcessor processor = new RenewalProcessor("caProfileSubmit", locale);
+                results = processor.processRenewal(cmsReq);
             } else {
-                continue;
+                CMS.debug("ProfileSubmitServlet: isRenewal false");
+                EnrollmentProcessor processor = new EnrollmentProcessor("caProfileSubmit", locale);
+                results = processor.processEnrollment(cmsReq);
             }
+        } catch (BadRequestDataException e) {
+            CMS.debug("ProfileSubmitServlet: bad data provided in processing request: " + e.toString());
+            errorExit(response, xmlOutput, e.getMessage(), null);
+            return;
+        } catch (EAuthzException e) {
+            CMS.debug("ProfileSubmitServlet: authorization error in processing request: " + e.toString());
+            errorExit(response, xmlOutput, e.getMessage(), null);
+            return;
+        } catch (EAuthException e) {
+            CMS.debug("ProfileSubmitServlet: authentication error in processing request: " + e.toString());
+            errorExit(response, xmlOutput, e.getMessage(), null);
+            return;
+        } catch (EBaseException e) {
+            e.printStackTrace();
+            CMS.debug("ProfileSubmitServlet: error in processing request: " + e.toString());
+            errorExit(response, xmlOutput, e.getMessage(), null);
+            return;
         }
-        return null;
-    }
 
-    /*
-     *   authenticate for renewal - more to add necessary params/values
-     *   to the session context
-     */
-    public IAuthToken authenticate(IProfileAuthenticator authenticator,
-            HttpServletRequest request, IRequest origReq, SessionContext context)
-            throws EBaseException {
-        IAuthToken authToken = authenticate(authenticator, request);
-        // For renewal, fill in necessary params
-        if (authToken != null) {
-            String ouid = origReq.getExtDataInString("auth_token.uid");
-            // if the orig cert was manually approved, then there was
-            // no auth token uid.  Try to get the uid from the cert dn
-            // itself, if possible
-            if (ouid == null) {
-                String sdn = (String) context.get("origSubjectDN");
-                if (sdn != null) {
-                    ouid = getUidFromDN(sdn);
-                    if (ouid != null)
-                        CMS.debug("ProfileSubmitServlet: renewal: authToken original uid not found");
-                }
-            } else {
-                CMS.debug("ProfileSubmitServlet: renewal: authToken original uid found in orig request auth_token");
-            }
-            String auid = authToken.getInString("uid");
-            if (auid != null) { // not through ssl client auth
-                CMS.debug("ProfileSubmitServlet: renewal: authToken uid found:" + auid);
-                // authenticated with uid
-                // put "orig_req.auth_token.uid" so that authz with
-                // UserOrigReqAccessEvaluator will work
-                if (ouid != null) {
-                    context.put("orig_req.auth_token.uid", ouid);
-                    CMS.debug("ProfileSubmitServlet: renewal: authToken original uid found:" + ouid);
-                } else {
-                    CMS.debug("ProfileSubmitServlet: renewal: authToken original uid not found");
+        IRequest[] reqs = (IRequest []) results.get(Processor.ARG_REQUESTS);
+        String errorCode = (String) results.get(Processor.ARG_ERROR_CODE);
+        String errorReason = (String) results.get(Processor.ARG_ERROR_REASON);
+        IProfile profile = (IProfile) results.get(Processor.ARG_PROFILE);
+        ArgSet args = new ArgSet();
+
+        if (errorCode != null) {
+            if (xmlOutput) {
+                String requestIds = "";
+                for (IRequest req : reqs) {
+                    requestIds += "  " + req.getRequestId().toString();
                 }
-            } else { // through ssl client auth?
-                CMS.debug("ProfileSubmitServlet: renewal: authToken uid not found:");
-                // put in orig_req's uid
-                if (ouid != null) {
-                    CMS.debug("ProfileSubmitServlet: renewal: origReq uid not null:" + ouid + ". Setting authtoken");
-                    authToken.set("uid", ouid);
-                    context.put(SessionContext.USER_ID, ouid);
-                } else {
-                    CMS.debug("ProfileSubmitServlet: renewal: origReq uid not found");
-                    //                      throw new EBaseException("origReq uid not found");
-                }
-            }
 
-            String userdn = origReq.getExtDataInString("auth_token.userdn");
-            if (userdn != null) {
-                CMS.debug("ProfileSubmitServlet: renewal: origReq userdn not null:" + userdn + ". Setting authtoken");
-                authToken.set("userdn", userdn);
+                outputError(response, errorCode, errorReason, requestIds);
             } else {
-                CMS.debug("ProfileSubmitServlet: renewal: origReq userdn not found");
-                //                      throw new EBaseException("origReq userdn not found");
-            }
-        } else {
-            CMS.debug("ProfileSubmitServlet: renewal: authToken null");
-        }
-        return authToken;
-    }
-
-    public IAuthToken authenticate(IProfileAuthenticator authenticator,
-            HttpServletRequest request) throws EBaseException {
-        AuthCredentials credentials = new AuthCredentials();
-
-        // build credential
-        Enumeration<String> authNames = authenticator.getValueNames();
+                ArgList requestlist = new ArgList();
 
-        if (authNames != null) {
-            while (authNames.hasMoreElements()) {
-                String authName = authNames.nextElement();
-
-                credentials.set(authName, request.getParameter(authName));
+                for (IRequest req : reqs) {
+                    ArgSet requestset = new ArgSet();
+                    requestset.set(ARG_REQUEST_ID, req.getRequestId().toString());
+                    requestlist.add(requestset);
+                }
+                args.set(ARG_REQUEST_LIST, requestlist);
+                args.set(ARG_ERROR_CODE, errorCode);
+                args.set(ARG_ERROR_REASON, errorReason);
+                outputTemplate(request, response, args);
             }
+            return;
         }
 
-        credentials.set("clientHost", request.getRemoteHost());
-        IAuthToken authToken = authenticator.authenticate(credentials);
+        if (xmlOutput) {
+            xmlOutput(response, profile, locale, reqs);
+        } else {
+            ArgList outputlist = new ArgList();
+            for (int k = 0; k < reqs.length; k++) {
 
-        SessionContext sc = SessionContext.getContext();
-        if (sc != null) {
-            sc.put(SessionContext.AUTH_MANAGER_ID, authenticator.getName());
-            String userid = authToken.getInString(IAuthToken.USER_ID);
-            if (userid != null) {
-                sc.put(SessionContext.USER_ID, userid);
+                setOutputIntoArgs(profile, outputlist, locale, reqs[k]);
+                args.set(ARG_OUTPUT_LIST, outputlist);
             }
-        }
-
-        return authToken;
-    }
 
-    private void setInputsIntoRequest(HttpServletRequest request, IProfile profile, IRequest req) {
-        Enumeration<String> inputIds = profile.getProfileInputIds();
+            CMS.debug("ProfileSubmitServlet: done serving");
 
-        if (inputIds != null) {
-            while (inputIds.hasMoreElements()) {
-                String inputId = inputIds.nextElement();
-                IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration<String> inputNames = profileInput.getValueNames();
+            ArgList requestlist = new ArgList();
 
-                if (inputNames != null) {
-                    while (inputNames.hasMoreElements()) {
-                        String inputName = inputNames.nextElement();
+            for (int k = 0; k < reqs.length; k++) {
+                ArgSet requestset = new ArgSet();
 
-                        if (request.getParameter(inputName) != null) {
-                            // special characters in subject names parameters must be escaped
-                            if (inputName.matches("^sn_.*")) {
-                                req.setExtData(inputName, escapeValueRfc1779(request.getParameter(inputName), false)
-                                        .toString());
-                            } else {
-                                req.setExtData(inputName, request.getParameter(inputName));
-                            }
-                        }
-                    }
-                }
+                requestset.set(ARG_REQUEST_ID,
+                        reqs[k].getRequestId().toString());
+                requestlist.add(requestset);
             }
-        }
-    }
+            args.set(ARG_REQUEST_LIST, requestlist);
+            args.set(ARG_ERROR_CODE, "0");
+            args.set(ARG_ERROR_REASON, "");
 
-    /*
-     * fill input info from orig request to the renew request.
-     * This is expected to be used by renewal where the request
-     * is retrieved from request record
-     */
-    private void setInputsIntoRequest(IRequest request, IProfile profile, IRequest req, Locale locale) {
-        // passing inputs into request
-        Enumeration<String> inputIds = profile.getProfileInputIds();
-
-        if (inputIds != null) {
-            while (inputIds.hasMoreElements()) {
-                String inputId = inputIds.nextElement();
-                IProfileInput profileInput = profile.getProfileInput(inputId);
-                Enumeration<String> inputNames = profileInput.getValueNames();
-
-                while (inputNames.hasMoreElements()) {
-                    String inputName = inputNames.nextElement();
-                    String inputValue = "";
-                    CMS.debug("ProfileSubmitServlet: setInputsIntoRequest() getting input name= " + inputName);
-                    try {
-                        inputValue = profileInput.getValue(inputName, locale, request);
-                    } catch (Exception e) {
-                        CMS.debug("ProfileSubmitServlet: setInputsIntoRequest() getvalue() failed: " + e.toString());
-                    }
-
-                    if (inputValue != null) {
-                        CMS.debug("ProfileSubmitServlet: setInputsIntoRequest() setting value in ctx:" + inputValue);
-                        req.setExtData(inputName, inputValue);
-                    } else {
-                        CMS.debug("ProfileSubmitServlet: setInputsIntoRequest() value null");
-                    }
-                }
-            }
+            outputTemplate(request, response, args);
         }
-
     }
 
     private void setOutputIntoArgs(IProfile profile, ArgList outputlist, Locale locale, IRequest req) {
@@ -418,7 +225,7 @@ public class ProfileSubmitServlet extends ProfileServlet {
 
                         try {
                             outputValue = profileOutput.getValue(outputName,
-                                        locale, req);
+                                    locale, req);
                         } catch (EProfileException e) {
                             CMS.debug("ProfileSubmitServlet: " + e.toString());
                         }
@@ -435,26 +242,23 @@ public class ProfileSubmitServlet extends ProfileServlet {
         }
     }
 
-    /**
-     * Process the HTTP request
-     * <P>
-     *
-     * (Certificate Request Processed - either an automated "EE" profile based cert acceptance, or an automated "EE"
-     * profile based cert rejection)
-     * <P>
-     *
-     * <ul>
-     * <li>http.param profileId ID of profile to use to process request
-     * <li>signed.audit LOGGING_SIGNED_AUDIT_CERT_REQUEST_PROCESSED used when a certificate request has just been
-     * through the approval process
-     * </ul>
-     *
-     * @param cmsReq the object holding the request and response information
-     * @exception EBaseException an error has occurred
-     */
-    public void process(CMSRequest cmsReq) throws EBaseException {
-        HttpServletRequest request = cmsReq.getHttpReq();
-        HttpServletResponse response = cmsReq.getHttpResp();
+    private void errorExit(HttpServletResponse response, boolean xmlOutput, String message, String requestId)
+            throws EBaseException {
+        if (xmlOutput) {
+            outputError(response, FAILED, message, requestId);
+        } else {
+            ArgSet args = new ArgSet();
+            args.set(ARG_ERROR_CODE, "1");
+            args.set(ARG_ERROR_REASON, message);
+            outputTemplate(xmlOutput, response, args);
+        }
+
+        for (String event : statEvents) {
+            endTiming(event);
+        }
+    }
+
+    private boolean getXMLOutput(HttpServletRequest request) {
         boolean xmlOutput = false;
 
         String v = request.getParameter("xml");
